import _typeof from "@babel/runtime/helpers/typeof";
import { useEffect, useRef } from 'react';
import Toast from '../../toast';
import '../../toast/style/css';
import PageBackListener from '../../page-back-listener';
export default (function () {
  var configOrContent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '再按一次返回键退出此页面';
  var effectRef = useRef();
  useEffect(function () {
    var l = new PageBackListener(function (reListen) {
      Toast.info(configOrContent);
      var duration = 2000;

      if (_typeof(configOrContent) === 'object' && configOrContent.duration && configOrContent.duration > 0) {
        duration = configOrContent.duration;
      }

      effectRef.current = window.setTimeout(function () {
        reListen();
      }, duration);
    });
    return function () {
      l.removeEffect();
      clearTimeout(effectRef.current);
    };
  }, []);
});