import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React from 'react';
import cn from 'classnames';
import LoadingOutlined from '@ant-design/icons/LoadingOutlined';
import { defaultPrefixCls } from '../_config/dict';
;
export default (function (props) {
  var _cn;

  var className = props.className,
      children = props.children,
      disabled = props.disabled,
      icon = props.icon,
      _props$type = props.type,
      type = _props$type === void 0 ? "default" : _props$type,
      loading = props.loading,
      _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? defaultPrefixCls : _props$prefixCls,
      shape = props.shape,
      onClick = props.onClick,
      _props$rootDom = props.rootDom,
      rootDom = _props$rootDom === void 0 ? 'a' : _props$rootDom,
      restProps = _objectWithoutProperties(props, ["className", "children", "disabled", "icon", "type", "loading", "prefixCls", "shape", "onClick", "rootDom"]);

  var iconDom = loading ? /*#__PURE__*/React.createElement(LoadingOutlined, null) : icon;
  return /*#__PURE__*/React.createElement(rootDom, _objectSpread(_objectSpread(_objectSpread({}, rootDom === 'a' ? {
    role: 'button'
  } : {}), {}, {
    className: cn("".concat(prefixCls, "-button"), (_cn = {}, _defineProperty(_cn, "".concat(prefixCls, "-button-primary"), type === 'primary'), _defineProperty(_cn, "".concat(prefixCls, "-button-warning"), type === 'warning'), _defineProperty(_cn, "".concat(prefixCls, "-button-disabled"), disabled), _defineProperty(_cn, "".concat(prefixCls, "-button-loading"), loading), _defineProperty(_cn, "".concat(prefixCls, "-button-text"), type === 'text'), _defineProperty(_cn, "".concat(prefixCls, "-button-link"), type === 'link'), _defineProperty(_cn, "".concat(prefixCls, "-button-circle"), shape === 'circle'), _defineProperty(_cn, "".concat(prefixCls, "-button-round"), shape === 'round'), _cn), className)
  }, restProps), {}, {
    onClick: disabled || loading ? undefined : onClick
  }), !!iconDom && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-icon")
  }, iconDom), children && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-button-children")
  }, children));
});