import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _typeof from "@babel/runtime/helpers/typeof";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React from 'react';
import cn from 'classnames';
import SwiperCore, { Virtual, Autoplay, Pagination } from 'swiper';
import { Swiper, SwiperSlide } from 'swiper/react';
import { isDef } from '../_util/index';
import { defaultPrefixCls } from '../_config/dict';
import 'swiper/swiper.min.css';
import 'swiper/components/pagination/pagination.min.css';
SwiperCore.use([Virtual, Autoplay, Pagination]);
;
export default (function (props) {
  var children = props.children,
      className = props.className,
      autoplay = props.autoplay,
      _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? defaultPrefixCls : _props$prefixCls,
      dots = props.dots,
      restProps = _objectWithoutProperties(props, ["children", "className", "autoplay", "prefixCls", "dots"]);

  var autoplayConfig = autoplay;
  var packedChildren = React.Children.map(children, function (child, i) {
    var key = child.key,
        type = child.type; // 如果元素有定义key值(一般使用时遍历场景更多),则使用这个key值,否则使用index

    var realKey = isDef(key) ? key : i; // 如果元素已经使用了SwiperSlide组件,整个复制并覆盖key值

    if (type === SwiperSlide) {
      return /*#__PURE__*/React.cloneElement(child, {
        key: realKey
      });
    } // 其他的使用SwiperSlide包裹一下


    return /*#__PURE__*/React.createElement(SwiperSlide, {
      key: realKey
    }, child);
  });

  if (typeof autoplay === 'boolean' && autoplay) {
    autoplayConfig = {
      disableOnInteraction: false
    };
  } else if (autoplay && _typeof(autoplay) === 'object') {
    autoplayConfig = _objectSpread({
      disableOnInteraction: false
    }, autoplay);
  }

  return /*#__PURE__*/React.createElement(Swiper, _extends({
    className: cn("".concat(prefixCls, "-carousel"), className),
    autoHeight: true,
    pagination: !!dots,
    autoplay: autoplayConfig
  }, restProps), packedChildren);
});