import _typeof from "@babel/runtime/helpers/typeof";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import cn from 'classnames';
import { defaultPrefixCls } from '../_config/dict';
;
;
var replaceTag = '$$prefix$$';
var classMap = {
  show: "".concat(replaceTag, "-fade-op-1"),
  hide: "".concat(replaceTag, "-fade-op-0")
};
var FadeStatusMap = {
  showing: 'showing',
  hiding: 'hiding'
};

var Fade = /*#__PURE__*/function (_React$Component) {
  _inherits(Fade, _React$Component);

  var _super = _createSuper(Fade);

  function Fade(props) {
    var _this;

    _classCallCheck(this, Fade);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "timer", undefined);

    var isElementShow = _this.getIsElementShow(props.show || false);

    var transitionClass = isElementShow ? props.show ? classMap.show : classMap.hide : classMap.hide;
    _this.state = {
      isElementShow: isElementShow,
      transitionClass: transitionClass
    };
    _this.handleTransitionEnd = _this.handleTransitionEnd.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Fade, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this2 = this;

      if (prevProps.show !== this.props.show) {
        clearTimeout(this.timer);

        if (this.props.show) {
          this.status = FadeStatusMap.showing;
          this.setState({
            isElementShow: true,
            transitionClass: classMap.hide
          }, function () {
            _this2.timer = window.setTimeout(function () {
              _this2.setState({
                transitionClass: classMap.show
              });
            }, 50);
          });
        } else {
          this.status = FadeStatusMap.hiding;
          this.setState({
            transitionClass: classMap.hide
          });
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.timer);
    }
  }, {
    key: "getIsElementShow",
    value: function getIsElementShow(showStatus) {
      if (showStatus) {
        return true;
      } else {
        return !this.props.needDestroy;
      }
    }
  }, {
    key: "getTimingFunction",
    value: function getTimingFunction() {
      var _this$props = this.props,
          show = _this$props.show,
          timingFunction = _this$props.timingFunction,
          showTimingFunction = _this$props.showTimingFunction,
          hideTimingFunction = _this$props.hideTimingFunction;

      if (show) {
        return showTimingFunction || timingFunction || undefined;
      }

      return hideTimingFunction || timingFunction || undefined;
    }
  }, {
    key: "handleTransitionEnd",
    value: function handleTransitionEnd() {
      var _this$props2 = this.props,
          onShow = _this$props2.onShow,
          onHide = _this$props2.onHide,
          onChange = _this$props2.onChange,
          needDestroy = _this$props2.needDestroy;

      if (this.status) {
        var _isShow = false;

        if (this.status === FadeStatusMap.hiding) {
          this.setState({
            isElementShow: !needDestroy
          }, function () {
            typeof onHide === 'function' && onHide();
          });
        }

        if (this.status === FadeStatusMap.showing) {
          _isShow = true;
          typeof onShow === 'function' && onShow();
        }

        typeof onChange === 'function' && onChange(_isShow);
        this.status = undefined;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props3 = this.props,
          show = _this$props3.show,
          propsChildren = _this$props3.children,
          speed = _this$props3.speed,
          delay = _this$props3.delay,
          needDestroy = _this$props3.needDestroy,
          limitTstProperty = _this$props3.limitTstProperty,
          timingFunction = _this$props3.timingFunction,
          showTimingFunction = _this$props3.showTimingFunction,
          hideTimingFunction = _this$props3.hideTimingFunction,
          prefixCls = _this$props3.prefixCls,
          className = _this$props3.className,
          style = _this$props3.style,
          onShow = _this$props3.onShow,
          onHide = _this$props3.onHide,
          onChange = _this$props3.onChange,
          _onTransitionEnd = _this$props3.onTransitionEnd,
          restProps = _objectWithoutProperties(_this$props3, ["show", "children", "speed", "delay", "needDestroy", "limitTstProperty", "timingFunction", "showTimingFunction", "hideTimingFunction", "prefixCls", "className", "style", "onShow", "onHide", "onChange", "onTransitionEnd"]);

      var _this$state = this.state,
          isElementShow = _this$state.isElementShow,
          transitionClass = _this$state.transitionClass;
      var children = React.Children.only(propsChildren);

      if (isElementShow && _typeof(children) === 'object') {
        return _objectSpread(_objectSpread({}, children), {}, {
          props: _objectSpread(_objectSpread(_objectSpread({}, children.props), restProps), {}, {
            style: _objectSpread(_objectSpread(_objectSpread({}, children.props.style || {}), {}, {
              transitionProperty: limitTstProperty ? 'opacity' : undefined
            }, style || {}), {}, {
              transitionDuration: "".concat(speed, "s"),
              transitionDelay: delay ? "".concat(delay, "s") : undefined,
              transitionTimingFunction: this.getTimingFunction()
            }),
            onTransitionEnd: function onTransitionEnd(e) {
              if (typeof _onTransitionEnd === 'function') {
                _onTransitionEnd(e);
              }

              var selfTransitionFunc = children.props.onTransitionEnd;

              if (typeof selfTransitionFunc === 'function') {
                selfTransitionFunc(e);
              }

              _this3.handleTransitionEnd();
            },
            className: cn(className, children.props.className, "".concat(prefixCls, "-fade"), transitionClass.replace(replaceTag, prefixCls))
          })
        });
      }

      return null;
    }
  }]);

  return Fade;
}(React.Component);

_defineProperty(Fade, "defaultProps", {
  show: false,
  delay: 0,
  speed: 0.5,
  needDestroy: false,
  prefixCls: defaultPrefixCls,
  limitTstProperty: true,
  showTimingFunction: '',
  hideTimingFunction: '',
  timingFunction: 'ease'
});

export default Fade;