import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React, { forwardRef, useState } from 'react';
import EyeInvisibleOutlined from '@ant-design/icons/EyeInvisibleOutlined';
import EyeOutlined from '@ant-design/icons/EyeOutlined';
import { defaultPrefixCls } from '../_config/dict';
import BaseInput from './input';
;
;

function PasswordInputItem(props, ref) {
  var type = props.type,
      _props$pwdVisible = props.pwdVisible,
      pwdVisible = _props$pwdVisible === void 0 ? true : _props$pwdVisible,
      _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? defaultPrefixCls : _props$prefixCls,
      addonAfter = props.addonAfter,
      restProps = _objectWithoutProperties(props, ["type", "pwdVisible", "prefixCls", "addonAfter"]);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      isVisible = _useState2[0],
      setIsVisible = _useState2[1];

  var inputType = isVisible ? 'text' : 'password';

  var onChangeVisible = function onChangeVisible() {
    setIsVisible(!isVisible);
  };

  var realAddonAfter = pwdVisible ? /*#__PURE__*/React.createElement(React.Fragment, null, isVisible ? /*#__PURE__*/React.createElement(EyeOutlined, {
    className: "".concat(prefixCls, "-input-icon"),
    onClick: onChangeVisible
  }) : /*#__PURE__*/React.createElement(EyeInvisibleOutlined, {
    className: "".concat(prefixCls, "-input-icon"),
    onClick: onChangeVisible
  }), addonAfter && addonAfter) : addonAfter;
  return /*#__PURE__*/React.createElement(BaseInput, _extends({}, restProps, {
    type: inputType,
    ref: ref,
    addonAfter: realAddonAfter
  }));
}

;
export default /*#__PURE__*/forwardRef(PasswordInputItem);