import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { useState, useRef, useImperativeHandle, forwardRef } from 'react';
import useUpdateEffect from '../_hook/useUpdateEffect/index';
import BaseInput from './input'; // 输入带空格分隔的手机号表单组件
// 如果手机号不需要空格分隔，请直接使用Input组件
// 在特殊黏贴场景下有一定问题

;
;

function formatPhoneNumber(realValue) {
  var arr = [];

  for (var i = 0; i < realValue.length; i++) {
    if (i === 3 || i === 7) {
      arr.push(' ');
    }

    arr.push(realValue[i]);
  }

  return arr.join('');
}

function PhoneInputItem(props, ref) {
  var value = props.value,
      defaultValue = props.defaultValue,
      noUsedMaxLength = props.maxLength,
      restProps = _objectWithoutProperties(props, ["value", "defaultValue", "maxLength"]);

  var maxLength = 11;

  var _useState = useState(value || defaultValue || ''),
      _useState2 = _slicedToArray(_useState, 2),
      v = _useState2[0],
      setV = _useState2[1];

  var componentRef = useRef();
  useUpdateEffect(function () {
    if (props.value !== undefined && value !== v) {
      setV(value || '');
    }
  }, [value, v]);

  var onRealChangeValue = function onRealChangeValue(realValue) {
    if (value === undefined) {
      setV(realValue);
    }

    if (typeof props.onChange === 'function') {
      props.onChange(realValue);
    }
  };

  var onHandlePosWhileChange = function onHandlePosWhileChange(newValue, startPos, endPos) {
    var newRealValue = newValue.replace(/[^0-9]/g, '');
    var start = startPos;
    var end = endPos;

    if (startPos && endPos && newRealValue.length >= v.length) {
      var newValidValue = newValue.slice(0, startPos).replace(/[^0-9]/g, '');

      if (newValidValue.length === 4) {
        start = 5;
        end = 5;
      } else if (newValidValue.length === 8) {
        start = 10;
        end = 10;
      }
    }

    return {
      start: start,
      end: end
    };
  };

  var handleChange = function handleChange(newV) {
    var newValue = newV.replace(/[^0-9]/g, '');

    if (newValue.length > maxLength) {
      return;
    }

    if (newValue !== v) {
      onRealChangeValue(newValue);
    } else {
      setTimeout(function () {
        if (componentRef.current) {
          componentRef.current.handlePosition();
        }
      });
    }
  };

  useImperativeHandle(ref, function () {
    return _objectSpread({}, componentRef.current);
  });
  return /*#__PURE__*/React.createElement(BaseInput, _extends({}, restProps, {
    type: "tel",
    ref: componentRef,
    value: formatPhoneNumber(v),
    onHandleSelectionPos: onHandlePosWhileChange,
    onChange: handleChange
  }));
}

export default /*#__PURE__*/forwardRef(PhoneInputItem);