import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { useState, useRef, useEffect } from 'react';
import Swiper from './swiper';
import { SwiperSlide } from 'swiper/react';
import { isDef } from '../_util/index';
import { defaultPrefixCls } from '../_config/dict';
import 'swiper/swiper.min.css';
;
;
;
;

function getItemReactNode(key, value) {
  return /*#__PURE__*/React.createElement(SwiperSlide, {
    key: key
  }, /*#__PURE__*/React.createElement("div", {
    className: "swiper-slide-content"
  }, value));
}

function recursionCascadeHandleData(arr, deep) {
  return arr.filter(function (item) {
    return isDef(item) && isDef(item.value);
  }).map(function (item) {
    var key = item.key;

    var o = _objectSpread(_objectSpread({}, item), {}, {
      key: key,
      $$react$$node: getItemReactNode(key, item.value)
    });

    if (isDef(o.children)) {
      o.children = recursionCascadeHandleData(o.children, deep + 1);
    }

    return o;
  });
}

function mapHandleData(arr) {
  return arr.filter(function (i) {
    return Array.isArray(i) && i.length;
  }).map(function (group) {
    return group.filter(function (i) {
      return isDef(i) && isDef(i.value);
    }).map(function (item) {
      var key = item.key;
      return _objectSpread(_objectSpread({}, item), {}, {
        key: key,
        $$react$$node: getItemReactNode(key, item.value)
      });
    });
  });
}

function recursionAppendDefaultV(arr, value, deep, returned) {
  if (!Array.isArray(arr) || !arr.length) {
    return;
  }

  if (isDef(value[deep])) {
    for (var i = 0; i < arr.length; i++) {
      var item = arr[i];

      if (item.key === value[deep]) {
        recursionAppendDefaultV(item.children, value, deep + 1, returned);
        return;
      }
    }

    returned[deep] = arr[0].key;
    recursionAppendDefaultV(arr[0].children, value, deep + 1, returned);
    return;
  }

  returned.push(arr[0].key);
  recursionAppendDefaultV(arr[0].children, value, deep + 1, returned);
}

export default (function (props) {
  var _props$data = props.data,
      data = _props$data === void 0 ? [] : _props$data,
      _props$defaultValue = props.defaultValue,
      defaultValue = _props$defaultValue === void 0 ? [] : _props$defaultValue,
      _props$defaultShowCou = props.defaultShowCount,
      defaultShowCount = _props$defaultShowCou === void 0 ? 6 : _props$defaultShowCou,
      onChange = props.onChange,
      _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? defaultPrefixCls : _props$prefixCls,
      minCols = props.minCols,
      restProps = _objectWithoutProperties(props, ["data", "defaultValue", "defaultShowCount", "onChange", "prefixCls", "minCols"]);

  var groups = []; // 是否级联

  var isCascade = !(!isDef(data[0]) || Array.isArray(data[0]));
  var handledData; // 预处理defaultValue

  var dv = _toConsumableArray(defaultValue);

  if (isCascade) {
    var invalidIndex = dv.findIndex(function (i) {
      return !isDef(i);
    });

    if (invalidIndex > -1) {
      dv = dv.slice(0, invalidIndex);
    }

    handledData = recursionCascadeHandleData(data, 0);

    if (dv.length === 0) {
      dv.push(handledData[0].key);
    }

    recursionAppendDefaultV(handledData, dv, 0, dv);
  } else {
    handledData = mapHandleData(data);
    dv = dv.slice(0, handledData.length);
    handledData.forEach(function (group, gI) {
      if (isDef(dv[gI])) {
        // 排查是否在选项序列中
        var isInOptions = false;

        for (var i = 0; i < group.length; i++) {
          var item = group[i];

          if (item.key === dv[gI]) {
            isInOptions = true;
            break;
          }
        }

        if (!isInOptions) {
          // 推入组别的第一个选项的key
          dv[gI] = group[0].key;
        }
      } else {
        // 推入组别的第一个选项的key
        dv[gI] = group[0].key;
      }
    });
  }

  var _useState = useState(dv),
      _useState2 = _slicedToArray(_useState, 2),
      valueState = _useState2[0],
      setValueState = _useState2[1];

  var triggerOnChangeRef = useRef();
  useEffect(function () {
    triggerOnChangeRef.current = function (swiper, valueIndex, dataBase, cascadeData) {
      var v = _toConsumableArray(valueState);

      v[valueIndex] = dataBase[swiper.activeIndex];

      if (cascadeData) {
        v = v.slice(0, valueIndex + 1);
        recursionAppendDefaultV(cascadeData, v, 0, v);
      }

      setValueState(v);
      typeof onChange === 'function' && onChange(v);
    };
  }, [valueState, onChange]);

  if (!isCascade) {
    groups = handledData.map(function (group, gI) {
      var currentColValue = valueState[gI];
      var initialSlide = 0;
      var groupKeyValue = [];
      var options = group.map(function (item, i) {
        if (currentColValue === item.key) {
          initialSlide = i;
        }

        groupKeyValue.push(item.key);
        return item.$$react$$node;
      });
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-picker-view-col"),
        key: gI
      }, /*#__PURE__*/React.createElement(Swiper, {
        className: "".concat(prefixCls, "-picker-view-col-content"),
        direction: "vertical",
        centeredSlides: true,
        initialSlide: initialSlide,
        slidesPerView: defaultShowCount,
        onSlideChange: function onSlideChange(swiper) {
          triggerOnChangeRef.current && triggerOnChangeRef.current(swiper, gI, groupKeyValue, false);
        }
      }, options), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-picker-view-col-indicator"),
        style: {
          height: "calc(100% / ".concat(defaultShowCount, ")")
        }
      }), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-picker-view-col-mask")
      }));
    });
  } else {
    var recursionPackSwiperDom = function recursionPackSwiperDom(recursionArrData, deep, value, returned) {
      var selectedIndex = 0;
      var groupKeyValue = [];
      var swiperSlides = recursionArrData.map(function (item, i) {
        if (item.key === value[deep]) {
          selectedIndex = i;
        }

        groupKeyValue.push(item.key);
        return item.$$react$$node;
      });
      var colKey = '';

      for (var i = 0; i < deep; i++) {
        colKey = colKey + value[i] + '-';
      }

      colKey += deep;
      returned.push( /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-picker-view-col"),
        key: colKey
      }, /*#__PURE__*/React.createElement(Swiper, {
        className: "".concat(prefixCls, "-picker-view-col-content"),
        direction: "vertical",
        centeredSlides: true,
        initialSlide: selectedIndex,
        slidesPerView: defaultShowCount,
        onSlideChange: function onSlideChange(swiper) {
          triggerOnChangeRef.current && triggerOnChangeRef.current(swiper, deep, groupKeyValue, recursionData);
        }
      }, swiperSlides), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-picker-view-col-indicator"),
        style: {
          height: "calc(100% / ".concat(defaultShowCount, ")")
        }
      }), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-picker-view-col-mask")
      })));

      if (recursionArrData[selectedIndex].children && recursionArrData[selectedIndex].children.length) {
        recursionPackSwiperDom(recursionArrData[selectedIndex].children, deep + 1, value, returned);
      }
    };

    var recursionData = handledData;
    recursionPackSwiperDom(recursionData, 0, valueState, groups);

    if (typeof minCols === 'number' && groups.length < minCols) {
      for (var i = groups.length; i < minCols; i++) {
        groups.push( /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-view-col"),
          key: i
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-view-col-indicator"),
          style: {
            height: "calc(100% / ".concat(defaultShowCount, ")")
          }
        }), /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-view-col-mask")
        })));
      }
    }
  }

  return /*#__PURE__*/React.createElement("div", _extends({}, restProps, {
    className: "".concat(prefixCls, "-picker-view")
  }), groups);
});