import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React, { useEffect, useRef, useState } from 'react';
import { Swiper as BaseReactSwiper } from 'swiper/react';
;
export default (function (props) {
  var _onInit = props.onInit,
      _onSlideChange = props.onSlideChange,
      otherProps = _objectWithoutProperties(props, ["onInit", "onSlideChange"]);

  var _useState = useState(document.readyState === 'complete'),
      _useState2 = _slicedToArray(_useState, 2),
      isReady = _useState2[0],
      setIsReady = _useState2[1]; // 设置initialSlide会在onInit之前调用onSlideChange方法
  // 因此该组件为了正确响应onSlideChange事件(即阻止设置初始值的onSlideChange事件)


  var isInit = useRef(false);
  useEffect(function () {
    if (!isReady) {
      var cb = function cb() {
        if (document.readyState === 'complete') {
          setIsReady(true);
        }
      };

      document.addEventListener('readystatechange', cb);
      return function () {
        document.removeEventListener('readystatechange', cb);
      };
    }
  }, []);

  if (!isReady) {
    return null;
  }

  return /*#__PURE__*/React.createElement(BaseReactSwiper, _extends({}, otherProps, {
    onInit: function onInit() {
      isInit.current = true;
      typeof _onInit === 'function' && _onInit.apply(void 0, arguments);
    },
    onSlideChange: function onSlideChange() {
      if (isInit.current) {
        typeof _onSlideChange === 'function' && _onSlideChange.apply(void 0, arguments);
      }
    }
  }));
});