import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import ReactDOM from 'react-dom';
;

function renderComponentNode(renderFn) {
  var prevProps = {};

  var render = function render() {
    console.error('renderFn is not a function');
  };

  var destroy = function destroy() {
    console.error('destroyFn is not a function');
  };

  var update = function update() {};

  if (typeof renderFn === 'function') {
    var div = document.createElement('div');
    document.body.appendChild(div);

    destroy = function destroy() {
      var unmountResult = ReactDOM.unmountComponentAtNode(div);

      if (unmountResult && div.parentNode) {
        div.parentNode.removeChild(div);
      }
    };

    render = function render(props) {
      var jsx = renderFn(_objectSpread(_objectSpread({}, prevProps), props || {}), update, destroy);
      prevProps = props || {};
      ReactDOM.render(jsx, div);
    };
  }

  update = function update(newProps) {
    render(newProps);
  };

  return {
    render: render,
    destroy: destroy,
    update: update
  };
}

export default renderComponentNode;