import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React from 'react';
import cn from 'classnames';
import { mergeClassNames } from './base';
import { defaultPrefixCls } from '../_config/dict';
;
export default (function (props) {
  var _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? defaultPrefixCls : _props$prefixCls,
      className = props.className,
      style = props.style,
      width = props.width,
      height = props.height,
      _props$shape = props.shape,
      shape = _props$shape === void 0 ? 'default' : _props$shape,
      _props$active = props.active,
      active = _props$active === void 0 ? false : _props$active,
      restProps = _objectWithoutProperties(props, ["prefixCls", "className", "style", "width", "height", "shape", "active"]);

  return /*#__PURE__*/React.createElement("div", _extends({}, restProps, {
    className: mergeClassNames(cn("".concat(prefixCls, "-skeleton-button"), className), {
      active: active,
      shape: shape
    }, prefixCls),
    style: _objectSpread({
      width: width || undefined,
      height: height || undefined
    }, style || {})
  }));
});