import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React from 'react';
import cn from 'classnames';
import { mergeClassNames } from './base';
import { defaultPrefixCls } from '../_config/dict';
;
export default (function (props) {
  var _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? defaultPrefixCls : _props$prefixCls,
      className = props.className,
      _props$width = props.width,
      width = _props$width === void 0 ? '61%' : _props$width,
      height = props.height,
      _props$rows = props.rows,
      rows = _props$rows === void 0 ? 3 : _props$rows,
      _props$active = props.active,
      active = _props$active === void 0 ? false : _props$active,
      restProps = _objectWithoutProperties(props, ["prefixCls", "className", "width", "height", "rows", "active"]);

  var renderRows = function renderRows() {
    var liList = [];

    for (var i = 0; i < rows; i++) {
      var isLastOne = i + 1 === rows;
      liList.push( /*#__PURE__*/React.createElement("li", {
        className: mergeClassNames("".concat(prefixCls, "-skeleton-p"), {
          active: active
        }, prefixCls),
        style: {
          width: Array.isArray(width) ? width[i] : isLastOne ? width : undefined,
          height: height || undefined
        },
        key: i
      }));
    }

    return liList;
  };

  return /*#__PURE__*/React.createElement("ul", _extends({
    className: cn("".concat(prefixCls, "-skeleton-paragraph"), className)
  }, restProps), renderRows());
});