"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _fadeIn = _interopRequireDefault(require("../fade/fadeIn"));

var _slideIn = _interopRequireDefault(require("../slide/slideIn"));

var _dict = require("../_config/dict");

require("../fade/style/css");

require("../slide/style/css");

;
;
;

function Drawer(props) {
  var _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? _dict.defaultPrefixCls : _props$prefixCls,
      className = props.className,
      _props$maskClosable = props.maskClosable,
      maskClosable = _props$maskClosable === void 0 ? true : _props$maskClosable,
      _props$visible = props.visible,
      visible = _props$visible === void 0 ? true : _props$visible,
      children = props.children,
      _props$direction = props.direction,
      direction = _props$direction === void 0 ? 'up' : _props$direction,
      onCancel = props.onCancel,
      onHide = props.onHide,
      onShow = props.onShow,
      _props$mask = props.mask,
      mask = _props$mask === void 0 ? true : _props$mask,
      restProps = (0, _objectWithoutProperties2["default"])(props, ["prefixCls", "className", "maskClosable", "visible", "children", "direction", "onCancel", "onHide", "onShow", "mask"]);
  var maskShowRef = (0, _react.useRef)(false);
  var contentEnterRef = (0, _react.useRef)(false);

  var handleStatusChange = function handleStatusChange() {
    if ((!mask || maskShowRef.current) && contentEnterRef.current) {
      typeof onShow === 'function' && onShow();
    }

    if ((!mask || !maskShowRef.current) && !contentEnterRef.current) {
      typeof onHide === 'function' && onHide();
    }
  };

  var standardDirection = 'up';

  if (direction === '↓') {
    standardDirection = 'down';
  }

  var onTriggerClose = function onTriggerClose() {
    typeof onCancel === 'function' && onCancel.apply(void 0, arguments);
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefixCls, "-drawer"), className)
  }, !!mask && /*#__PURE__*/_react["default"].createElement(_fadeIn["default"], {
    show: visible,
    onShow: function onShow() {
      maskShowRef.current = true;
      handleStatusChange();
    },
    onHide: function onHide() {
      maskShowRef.current = false;
      handleStatusChange();
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-drawer-mask"),
    onClick: maskClosable ? function () {
      onTriggerClose();
    } : undefined
  })), /*#__PURE__*/_react["default"].createElement(_slideIn["default"], {
    direction: direction,
    show: visible,
    onShow: function onShow() {
      contentEnterRef.current = true;
      handleStatusChange();
    },
    onHide: function onHide() {
      contentEnterRef.current = false;
      handleStatusChange();
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefixCls, "-drawer-content"), "".concat(prefixCls, "-drawer-d-").concat(standardDirection))
  }, /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    className: "".concat(prefixCls, "-drawer-box")
  }, restProps), typeof children === 'function' ? children(onTriggerClose) : children))));
}

var _default = Drawer;
exports["default"] = _default;