"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _index = _interopRequireDefault(require("../_hook/useUpdateEffect/index"));

var _input = _interopRequireDefault(require("./input"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

;
;

function formatPhoneNumber(realValue) {
  var arr = [];

  for (var i = 0; i < realValue.length; i++) {
    if (i === 3 || i === 7) {
      arr.push(' ');
    }

    arr.push(realValue[i]);
  }

  return arr.join('');
}

function PhoneInputItem(props, ref) {
  var value = props.value,
      defaultValue = props.defaultValue,
      noUsedMaxLength = props.maxLength,
      restProps = (0, _objectWithoutProperties2["default"])(props, ["value", "defaultValue", "maxLength"]);
  var maxLength = 11;

  var _useState = (0, _react.useState)(value || defaultValue || ''),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      v = _useState2[0],
      setV = _useState2[1];

  var componentRef = (0, _react.useRef)();
  (0, _index["default"])(function () {
    if (props.value !== undefined && value !== v) {
      setV(value || '');
    }
  }, [value, v]);

  var onRealChangeValue = function onRealChangeValue(realValue) {
    if (value === undefined) {
      setV(realValue);
    }

    if (typeof props.onChange === 'function') {
      props.onChange(realValue);
    }
  };

  var onHandlePosWhileChange = function onHandlePosWhileChange(newValue, startPos, endPos) {
    var newRealValue = newValue.replace(/[^0-9]/g, '');
    var start = startPos;
    var end = endPos;

    if (startPos && endPos && newRealValue.length >= v.length) {
      var newValidValue = newValue.slice(0, startPos).replace(/[^0-9]/g, '');

      if (newValidValue.length === 4) {
        start = 5;
        end = 5;
      } else if (newValidValue.length === 8) {
        start = 10;
        end = 10;
      }
    }

    return {
      start: start,
      end: end
    };
  };

  var handleChange = function handleChange(newV) {
    var newValue = newV.replace(/[^0-9]/g, '');

    if (newValue.length > maxLength) {
      return;
    }

    if (newValue !== v) {
      onRealChangeValue(newValue);
    } else {
      setTimeout(function () {
        if (componentRef.current) {
          componentRef.current.handlePosition();
        }
      });
    }
  };

  (0, _react.useImperativeHandle)(ref, function () {
    return _objectSpread({}, componentRef.current);
  });
  return /*#__PURE__*/_react["default"].createElement(_input["default"], (0, _extends2["default"])({}, restProps, {
    type: "tel",
    ref: componentRef,
    value: formatPhoneNumber(v),
    onHandleSelectionPos: onHandlePosWhileChange,
    onChange: handleChange
  }));
}

var _default = /*#__PURE__*/(0, _react.forwardRef)(PhoneInputItem);

exports["default"] = _default;