"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _index = _interopRequireDefault(require("../portal-factory/index"));

var _modal = _interopRequireDefault(require("./modal"));

require("../fade/style/css");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Modal = function Modal(props) {
  return /*#__PURE__*/_reactDom["default"].createPortal( /*#__PURE__*/_react["default"].createElement(_modal["default"], props), document.body);
}; // Feature 是否存在更好的实现方式，如Symbol


var closeFnCallFlag = '@@__symbols__fromCloseFn_';

var renderModal = function renderModal(props, update, destroy) {
  var content = props.content,
      children = props.children,
      onOk = props.onOk,
      onHide = props.onHide,
      onCancel = props.onCancel,
      restProps = (0, _objectWithoutProperties2["default"])(props, ["content", "children", "onOk", "onHide", "onCancel"]);
  var isInClosing = !!props[closeFnCallFlag];
  delete restProps[closeFnCallFlag];

  var close = function close() {
    var _objectSpread2;

    if (isInClosing) {
      return;
    }

    var newProps = _objectSpread(_objectSpread({}, props), {}, (_objectSpread2 = {}, (0, _defineProperty2["default"])(_objectSpread2, closeFnCallFlag, true), (0, _defineProperty2["default"])(_objectSpread2, "visible", false), _objectSpread2));

    update(newProps);
  };

  var onHideFn = function onHideFn() {
    typeof onHide === 'function' && onHide(); // 判断是否由close方法引发的onHide
    // onShow/onHide 是由 Fade 组件提供的, Fade 组件判断
    // 在transitionend时触发何种回调,是根据内部的status
    // 变量进行判断的。快速方法没有暴露任何操作show参数、
    // 更新组件props的方法，因此 onHide 回调只能是关闭引发的
    // if (isInClosing) {
    // }

    destroy();
  };

  var onOkFn = function onOkFn() {
    typeof onOk === 'function' ? onOk(close) : close();
  };

  var onCancelFn = function onCancelFn() {
    typeof onCancel === 'function' ? onCancel(close) : close();
  };

  return /*#__PURE__*/_react["default"].createElement(_modal["default"], (0, _extends2["default"])({}, restProps, {
    onHide: onHideFn,
    onOk: onOkFn,
    onCancel: onCancelFn
  }), content || children);
};

Modal.info = function (config) {
  var modalProps = _objectSpread({
    confirmable: false,
    cancelText: '确定'
  }, config);

  var pf = (0, _index["default"])(renderModal);
  pf.render(modalProps);
};

Modal.confirm = function (config) {
  var modalProps = _objectSpread({}, config);

  var pf = (0, _index["default"])(renderModal);
  pf.render(modalProps);
};

Modal.showCustom = function (config) {
  var modalProps = _objectSpread({
    maskClosable: true,
    customStructure: true
  }, config);

  var pf = (0, _index["default"])(renderModal);
  pf.render(modalProps);
};

var _default = Modal;
exports["default"] = _default;