"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _dict = require("../_config/dict");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

;
;
var prefixFlag = '__prefix__';
var directionFlag = '__direction__';
var ClassMap = {
  begin: "".concat(prefixFlag, "-slide-begin-").concat(directionFlag),
  show: "".concat(prefixFlag, "-slide-op-1"),
  hide: "".concat(prefixFlag, "-slide-op-0"),
  end: ''
};
var SlideStatus = {
  enter: 'enter',
  exit: 'exit'
};

var Slide = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Slide, _React$Component);

  var _super = _createSuper(Slide);

  function Slide(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, Slide);
    _this = _super.call(this, props);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "timer", undefined);

    var isElementShow = _this.getIsElementShow(props.show || false);

    var transitionClass = _this.getTransitionClass(!!props.show);

    _this.state = {
      isElementShow: isElementShow,
      transitionClass: transitionClass
    };
    _this.handleTransitionEnd = _this.handleTransitionEnd.bind((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }

  (0, _createClass2["default"])(Slide, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this2 = this;

      if (prevProps.show !== this.props.show) {
        if (this.props.show) {
          this.status = SlideStatus.enter;
          this.setState({
            isElementShow: true,
            transitionClass: this.getTransitionClass(false)
          }, function () {
            clearTimeout(_this2.timer);
            _this2.timer = window.setTimeout(function () {
              _this2.setState({
                transitionClass: _this2.getTransitionClass(true)
              });
            }, 50);
          });
        } else {
          this.status = SlideStatus.exit;
          this.setState({
            transitionClass: this.getTransitionClass(false)
          });
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.timer);
    }
  }, {
    key: "getIsElementShow",
    value: function getIsElementShow(showStatus) {
      if (showStatus) {
        return true;
      } else {
        return !this.props.needDestroy;
      }
    }
  }, {
    key: "getTransitionProperty",
    value: function getTransitionProperty() {
      var _this$props = this.props,
          opacityTst = _this$props.opacityTst,
          limitTstProperty = _this$props.limitTstProperty;
      var pv = undefined;

      if (limitTstProperty) {
        pv = 'transform';

        if (opacityTst) {
          pv += ',opacity';
        }
      }

      return pv;
    }
  }, {
    key: "getTransitionClass",
    value: function getTransitionClass(show) {
      var opacityTst = this.props.opacityTst;

      if (!show) {
        return (0, _classnames["default"])(ClassMap.begin, (0, _defineProperty2["default"])({}, ClassMap.hide, opacityTst));
      }

      return (0, _classnames["default"])(ClassMap.end, (0, _defineProperty2["default"])({}, ClassMap.show, opacityTst));
    }
  }, {
    key: "getTimingFunction",
    value: function getTimingFunction() {
      var _this$props2 = this.props,
          show = _this$props2.show,
          timingFunction = _this$props2.timingFunction,
          showTimingFunction = _this$props2.showTimingFunction,
          hideTimingFunction = _this$props2.hideTimingFunction;

      if (show) {
        return showTimingFunction || timingFunction || undefined;
      }

      return hideTimingFunction || timingFunction || undefined;
    }
  }, {
    key: "getStandardDirection",
    value: function getStandardDirection(direction) {
      switch (direction) {
        case '←':
          return 'left';

        case '↑':
          return 'up';

        case '→':
          return 'right';

        case '↓':
          return 'down';

        default:
          return direction;
      }

      ;
    }
  }, {
    key: "parseTransitionClass",
    value: function parseTransitionClass(className) {
      var _this$props3 = this.props,
          prefixCls = _this$props3.prefixCls,
          direction = _this$props3.direction;
      var prefixReg = new RegExp(prefixFlag, 'g');
      var directionReg = new RegExp(directionFlag, 'g');
      return className.replace(prefixReg, prefixCls).replace(directionReg, this.getStandardDirection(direction));
    }
  }, {
    key: "handleTransitionEnd",
    value: function handleTransitionEnd() {
      var _this3 = this;

      var _this$props4 = this.props,
          onShow = _this$props4.onShow,
          onHide = _this$props4.onHide,
          onChange = _this$props4.onChange,
          direction = _this$props4.direction;

      if (this.status) {
        var _isEnter = true;

        if (this.status === SlideStatus.enter) {
          typeof onShow === 'function' && onShow(this.getStandardDirection(direction));
        }

        if (this.status === SlideStatus.exit) {
          _isEnter = false;
          this.setState({
            isElementShow: this.getIsElementShow(false)
          }, function () {
            typeof onHide === 'function' && onHide(_this3.getStandardDirection(direction));
          });
        }

        this.status = '';
        typeof onChange === 'function' && onChange(this.getStandardDirection(direction), _isEnter);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props5 = this.props,
          show = _this$props5.show,
          speed = _this$props5.speed,
          delay = _this$props5.delay,
          direction = _this$props5.direction,
          opacityTst = _this$props5.opacityTst,
          limitTstProperty = _this$props5.limitTstProperty,
          needDestroy = _this$props5.needDestroy,
          showTimingFunction = _this$props5.showTimingFunction,
          hideTimingFunction = _this$props5.hideTimingFunction,
          timingFunction = _this$props5.timingFunction,
          onShow = _this$props5.onShow,
          onHide = _this$props5.onHide,
          onChange = _this$props5.onChange,
          _onTransitionEnd = _this$props5.onTransitionEnd,
          propsChildren = _this$props5.children,
          prefixCls = _this$props5.prefixCls,
          className = _this$props5.className,
          style = _this$props5.style,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props5, ["show", "speed", "delay", "direction", "opacityTst", "limitTstProperty", "needDestroy", "showTimingFunction", "hideTimingFunction", "timingFunction", "onShow", "onHide", "onChange", "onTransitionEnd", "children", "prefixCls", "className", "style"]);
      var _this$state = this.state,
          isElementShow = _this$state.isElementShow,
          transitionClass = _this$state.transitionClass;

      var children = _react["default"].Children.only(propsChildren);

      if (isElementShow && (0, _typeof2["default"])(children) === 'object') {
        return _objectSpread(_objectSpread({}, children), {}, {
          props: _objectSpread(_objectSpread(_objectSpread({}, children.props), restProps), {}, {
            style: _objectSpread(_objectSpread(_objectSpread({}, children.props.style || {}), {}, {
              transitionProperty: this.getTransitionProperty()
            }, style || {}), {}, {
              transitionDuration: "".concat(speed, "s"),
              transitionDelay: delay ? "".concat(delay, "s") : undefined,
              transitionTimingFunction: this.getTimingFunction()
            }),
            onTransitionEnd: function onTransitionEnd(e) {
              if (typeof _onTransitionEnd === 'function') {
                _onTransitionEnd(e);
              }

              var selfTransitionFunc = children.props.onTransitionEnd;

              if (typeof selfTransitionFunc === 'function') {
                selfTransitionFunc(e);
              }

              _this4.handleTransitionEnd();
            },
            className: (0, _classnames["default"])(className, children.props.className, "".concat(prefixCls, "-slide"), this.parseTransitionClass(transitionClass))
          })
        });
      }

      return null;
    }
  }]);
  return Slide;
}(_react["default"].Component);

(0, _defineProperty2["default"])(Slide, "defaultProps", {
  show: false,
  direction: 'down',
  speed: 0.5,
  delay: 0,
  prefixCls: _dict.defaultPrefixCls,
  needDestroy: false,
  showTimingFunction: '',
  hideTimingFunction: '',
  timingFunction: 'ease',
  limitTstProperty: true,
  opacityTst: true
});
;
var _default = Slide;
exports["default"] = _default;