"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _LoadingOutlined = _interopRequireDefault(require("@ant-design/icons/LoadingOutlined"));

var _countDown = _interopRequireDefault(require("../count-down"));

var _dict = require("../_config/dict");

var _useRefState3 = _interopRequireDefault(require("../_hook/useRefState"));

;
;

var _default = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var className = props.className,
      _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? _dict.defaultPrefixCls : _props$prefixCls,
      disabled = props.disabled,
      initDispatch = props.initDispatch,
      onClick = props.onClick,
      _props$duration = props.duration,
      duration = _props$duration === void 0 ? 60 : _props$duration,
      onClickDisabled = props.onClickDisabled,
      _props$text = props.text,
      text = _props$text === void 0 ? '获取验证码' : _props$text,
      _props$reText = props.reText,
      reText = _props$reText === void 0 ? '获取验证码' : _props$reText,
      renderCountDown = props.renderCountDown,
      restProps = (0, _objectWithoutProperties2["default"])(props, ["className", "prefixCls", "disabled", "initDispatch", "onClick", "duration", "onClickDisabled", "text", "reText", "renderCountDown"]);
  var needinitDispatch = !disabled && initDispatch;

  var _useState = (0, _react.useState)(true),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      isFirst = _useState2[0],
      setIsFirst = _useState2[1];

  var _useRefState = (0, _useRefState3["default"])(needinitDispatch && typeof onClick === 'function' ? true : false),
      _useRefState2 = (0, _slicedToArray2["default"])(_useRefState, 2),
      isLoadingRef = _useRefState2[0],
      setIsLoading = _useRefState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      isWaitting = _useState4[0],
      setIsWaitting = _useState4[1];

  var beginCountDownFn = function beginCountDownFn() {
    setIsWaitting(true);
    setIsLoading(false);
    setIsFirst(false);
  };

  var cancelCountDown = function cancelCountDown() {
    setIsWaitting(false);
  };

  var cancelLoading = function cancelLoading() {
    setIsLoading(false);
  };

  var triggerOnClick = function triggerOnClick() {
    if (typeof onClick === 'function') {
      setIsLoading(true);

      var _flowControlFn = function _flowControlFn() {
        var isContinue = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

        if (isContinue) {
          beginCountDownFn();
        } else {
          cancelLoading();
        }
      };

      onClick(_flowControlFn);
    } else {
      beginCountDownFn();
    }
  };

  (0, _react.useEffect)(function () {
    if (needinitDispatch) {
      triggerOnClick();
    }
  }, []);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      cancelCountDown: cancelCountDown
    };
  });

  var onHandleCountDownFinished = function onHandleCountDownFinished() {
    cancelCountDown();
  };

  var onClickItem = function onClickItem() {
    if (isLoadingRef.current || isWaitting) {
      return;
    }

    if (disabled) {
      typeof onClickDisabled === 'function' && onClickDisabled();
      return;
    }

    triggerOnClick();
  };

  var renderContent = function renderContent() {
    if (isLoadingRef.current) {
      return /*#__PURE__*/_react["default"].createElement(_LoadingOutlined["default"], null);
    }

    if (isWaitting) {
      return /*#__PURE__*/_react["default"].createElement(_countDown["default"], {
        duration: duration,
        formatString: "s",
        onFinished: onHandleCountDownFinished
      }, function (timeStr) {
        if (typeof renderCountDown === 'function') {
          return renderCountDown(timeStr);
        }

        return "".concat(timeStr, "s");
      });
    }

    return isFirst ? text : reText;
  };

  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, restProps, {
    className: (0, _classnames["default"])("".concat(prefixCls, "-sms-code-btn"), className, (0, _defineProperty2["default"])({}, "".concat(prefixCls, "-sms-code-btn-disabled"), disabled || isWaitting)),
    onClick: onClickItem
  }), renderContent());
});

exports["default"] = _default;