"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _fadeIn = _interopRequireDefault(require("../fade/fadeIn"));

var _classnames = _interopRequireDefault(require("classnames"));

var _dict = require("../_config/dict");

;

var _default = function _default(props) {
  var _cn, _cn2;

  var _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? _dict.defaultPrefixCls : _props$prefixCls,
      className = props.className,
      round = props.round,
      _props$smooth = props.smooth,
      smooth = _props$smooth === void 0 ? true : _props$smooth,
      _props$duration = props.duration,
      duration = _props$duration === void 0 ? 2000 : _props$duration,
      icon = props.icon,
      _props$at = props.at,
      at = _props$at === void 0 ? 'center' : _props$at,
      transitionSpeed = props.transitionSpeed,
      content = props.content,
      onHide = props.onHide;

  var _useState = (0, _react.useState)(true),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      isShow = _useState2[0],
      setIsShow = _useState2[1];

  var timer = (0, _react.useRef)();
  (0, _react.useEffect)(function () {
    return function () {
      if (timer.current) {
        clearTimeout(timer.current);
      }
    };
  }, []);

  var doHide = function doHide() {
    setIsShow(false);
  };

  var onShowCb = function onShowCb() {
    if (duration !== 0) {
      timer.current = window.setTimeout(function () {
        doHide();
      }, duration);
    }
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefixCls, "-toast"), (_cn = {}, (0, _defineProperty2["default"])(_cn, "".concat(prefixCls, "-toast-at-top"), at === 'top'), (0, _defineProperty2["default"])(_cn, "".concat(prefixCls, "-toast-at-bottom"), at === 'bottom'), _cn), className)
  }, /*#__PURE__*/_react["default"].createElement(_fadeIn["default"], {
    show: isShow,
    onHide: onHide,
    onShow: onShowCb,
    speed: transitionSpeed
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefixCls, "-toast-content"), (_cn2 = {}, (0, _defineProperty2["default"])(_cn2, "".concat(prefixCls, "-toast-round"), round), (0, _defineProperty2["default"])(_cn2, "".concat(prefixCls, "-toast-smooth"), smooth), (0, _defineProperty2["default"])(_cn2, "".concat(prefixCls, "-toast-has-icon"), !!icon), _cn2))
  }, icon, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-toast-text")
  }, content))));
};

exports["default"] = _default;