import React from 'react';
import '../fade/style/css';
import '../slide/style/css';
export declare type Directions = 'up' | 'down' | '↑' | '↓';
export interface DrawerCommonProps {
    prefixCls?: string;
    className?: string;
    maskClosable?: boolean;
    direction?: Directions;
    visible?: boolean;
    mask?: boolean;
    onHide?: () => void;
    onShow?: () => void;
}
declare type CancelFn = (...customParams: any[]) => void;
export interface DrawerProps extends DrawerCommonProps {
    children?: React.ReactNode | ((onCancel: CancelFn) => React.ReactNode);
    onCancel?: CancelFn;
    [key: string]: any;
}
export interface QuickDrawerProps extends DrawerCommonProps {
    content?: React.ReactNode | ((onCancel: CancelFn) => React.ReactNode);
    onCancel?: (close: () => void, ...customParams: any[]) => void;
    [key: string]: any;
}
declare function Drawer(props: DrawerProps): JSX.Element;
export default Drawer;
