import React from 'react';
export interface FadeProps {
    show?: boolean;
    speed?: number;
    delay?: number;
    limitTstProperty?: boolean;
    needDestroy?: boolean;
    showTimingFunction?: string;
    hideTimingFunction?: string;
    timingFunction?: string;
    children?: React.ReactNode;
    prefixCls?: string;
    onTransitionEnd?: (e?: TransitionEvent) => void;
    onShow?: () => void;
    onHide?: () => void;
    onChange?: (isShow?: boolean) => void;
    className?: string;
    style?: React.CSSProperties;
    [key: string]: any;
}
export interface FadeState {
    isElementShow: boolean;
    transitionClass: string;
}
declare class Fade extends React.Component<FadeProps, FadeState> {
    static defaultProps: {
        show: boolean;
        delay: number;
        speed: number;
        needDestroy: boolean;
        prefixCls: string;
        limitTstProperty: boolean;
        showTimingFunction: string;
        hideTimingFunction: string;
        timingFunction: string;
    };
    timer: number | undefined;
    status: string | undefined;
    constructor(props: FadeProps);
    componentDidUpdate(prevProps: FadeProps): void;
    componentWillUnmount(): void;
    getIsElementShow(showStatus: boolean): boolean;
    getTimingFunction(): string | undefined;
    handleTransitionEnd(): void;
    render(): {
        props: any;
    } | {
        props: any;
        type: string | React.JSXElementConstructor<any>;
        key: React.Key | null;
    } | {
        props: any;
        key: React.Key | null;
        children: React.ReactNode;
        type: string | React.JSXElementConstructor<any>;
    } | null;
}
export default Fade;
