import React from 'react';
export declare type StandardDirections = 'up' | 'down' | 'left' | 'right';
export declare type Directions = '↑' | '↓' | '←' | '→' | StandardDirections;
export interface SlideProps {
    show?: boolean;
    speed?: number;
    delay?: number;
    direction?: Directions;
    opacityTst?: boolean;
    limitTstProperty?: boolean;
    needDestroy?: boolean;
    showTimingFunction?: string;
    hideTimingFunction?: string;
    timingFunction?: string;
    onShow?: (direction?: StandardDirections) => void;
    onHide?: (direction?: StandardDirections) => void;
    onChange?: (direction?: StandardDirections, isEnter?: boolean) => void;
    children?: React.ReactNode;
    prefixCls?: string;
    onTransitionEnd?: (e?: TransitionEvent) => void;
    className?: string;
    style?: React.CSSProperties;
    [key: string]: any;
}
export interface SlideState {
    isElementShow: boolean;
    transitionClass: string;
}
declare class Slide extends React.Component<SlideProps, SlideState> {
    static defaultProps: {
        show: boolean;
        direction: Directions;
        speed: number;
        delay: number;
        prefixCls: string;
        needDestroy: boolean;
        showTimingFunction: string;
        hideTimingFunction: string;
        timingFunction: string;
        limitTstProperty: boolean;
        opacityTst: boolean;
    };
    timer: number | undefined;
    status: string | undefined;
    constructor(props: SlideProps);
    componentDidUpdate(prevProps: SlideProps): void;
    componentWillUnmount(): void;
    getIsElementShow(showStatus: boolean): boolean;
    getTransitionProperty(): string | undefined;
    getTransitionClass(show: boolean): string;
    getTimingFunction(): string | undefined;
    getStandardDirection(direction: Directions): StandardDirections;
    parseTransitionClass(className: string): string;
    handleTransitionEnd(): void;
    render(): {
        props: any;
    } | {
        props: any;
        type: string | React.JSXElementConstructor<any>;
        key: React.Key | null;
    } | {
        props: any;
        key: React.Key | null;
        children: React.ReactNode;
        type: string | React.JSXElementConstructor<any>;
    } | null;
}
export default Slide;
